/*
 * (C) 2005 by Bengt Martensson <nospam@bengt-martensson.de>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

!transformation

!begin []
"// This file was automatically generated, do not edit\n",
"const int no_properties = ",
  count(source.child[?properties].child),
  ";\n",
"const int no_entries = ",
  count(source.child[?properties].child:1.child[?value]),
  ";\n",
  "const int no_rules = ",
  count(source.child[?rules].child.child[^?text]),
  ";\n\n",
  "enum properties { ",
  join(source.child[?properties].child.@name, ", "),
  " };\n\n",
  source.child[?properties].child[@name ^== "position"],

  "\nconst char *property_words[no_properties] = {\"" ||
  join((source.child[?properties].child.@name||"         ").substring(1,8), "\", \"") ||
"\"};\n",
  <|words-table|>node{source.child[?properties].child},
  source.child.child.child[?subset],

  (source.child[?properties].child[@name == "position"] & "#define HAVE_POSITION\n"),
"#include \"generic.cpp\"\n",

  <|ruledef|>source.child[?rules].child.child[^?text],
 
    "\nint main(int argc, char * argv[])\n",
    "{\n",
    "   table *tables[no_properties];\n",

    <|tableentry|>source.child[?properties].child,
    <|setup-rulestable|>source.child[?rules].child.child[^?text],

    "   if (argc > 1)\n",
    "     decode_debugarg(argv[1]);\n",

    "   bool result = process(tables, 0);\n",

    "   std::cerr << (result ? \"Problem has (at least) one solution.\\n\" :\n",
    "	   \"Problem has no solution.\\n\");\n",

    "   return result ? 0 :  1;\n",
    "}\n"
;

subset []
!insert
"const bool " || self.@name || "[no_entries] = { // Subset of " || self.r.parent.@name || "\n",
self.r.parent.child[?value],
"\n};\n"
;

value [parent[?subset]]
!replace 
if(self.r.data == self.parent.r.child.data, "true", "false"),
self.right & ", "
  ;

words-table []
!replace "const char *words[no_properties][no_entries] = {\n",
<|props|>self.r.child, "};\n";

property [^parent[?words-table]]
!replace
"enum " || self.@name || " { " || join(self.r.child[?value].data, ", ") || "};\n"
;

props []
!replace
"  { \"", 
 join((self.r.child[?value].data||"       ").substring(1,8),"\", \""),
 "\" }",
(self.right[?props] & ","),
"\n"
;

value []
!replace "\"" || (self.r.data || "         ").substring(1,8) || "\"";

tableentry []
!replace 
"   tables[", count(self.r.left[?property]), "] = new table(\"", (self.r.@name||"      ").substring(1,8),
"\", ", self.r.@name, ");\n";

setup-rulestable []
!replace
(*i := count(source.child[?rules].child.child[^?text]) - count(self.right[^?text]) - 1).null,
"   rules[", *i, "] = rule" || *i,
 ";\n"
;

ruledef []
!replace 
(*i := count(source.child[?rules].child.child[^?text]) - count(self.right[?ruledef]) - 1).null,
"void rule", *i, "(table &t) {", self.r.gid, count(self.r.child), "(t, ", self.r.child, ");};\n";

property-value []
!replace
self.@name, ", ", self.@value,
(self.right[?property-value] & ", ")
;
